/*
 *      lcopy.c
 *      Zeilenweise bis EOF lesen und ausgeben
 *      klin, Thu Nov 18 13:08:47 1999
 */

#include <stdio.h>

#define MAX 256 /* Max. Anzahl von Zeichen */

int getline(char *, int);       /* Prototyp */

void main(void)
{
  char st[MAX]; /* Feld fuer String */
  int l;        /* Zeichenzaehler */
  
  /* Zeilenweise bis EOF lesen und ausgeben */
  while( (l = getline(st, MAX - 1)) != EOF) {
    printf("%3d: %s\n", l, st);
  }
  
} /* main() */

/* Eine Zeile bis EOF, NL oder max lesen */
int getline(char *s, int max)
{
  int n = 0;    /* Zaehler */
  int c;        /* Zeichen */
  
  /* Schleife bis NL, MAX oder EOF */
  while ( n < max && (c = getchar()) != EOF && c != '\n') {
    s[n++] = c;
  } 
  /* String terminieren */
  s[n] = '\0';
  /* Anzahl Zeichen bzw. EOF rueckgeben */
  if (c == EOF)
    return(EOF);
  else
    return(n);
  
} /* getline() */
