/*
 *      strout.c
 *      Strings einlesen, dynamisch speichern
 *      und mit Zeilennummer ausgeben
 *      Wed Dec 15 16:31:29 1999
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NBUF 1024       /* Groesse des Einlesepuffers */
#define NSTR 256        /* Groesse des Stringvektors  */

void main(void)
{
  char *str[NSTR];      /* Stringvektor  */
  char buf[NBUF];       /* Einlesepuffer */
  int nstr = 0;         /* Zeilenzaehler */
  char *bp;             /* Stringpointer */
  int len;              /* Laenge        */
  int n;                /* Zaehler       */

  /* Strings in Vektor str einlesen */
  while (gets(buf) != NULL && nstr < NSTR) {
    /* Stringlaenge feststellen */
    len = strlen(buf);
    /* Speicherplatz auf Heap reservieren: len + 1 */
    if ((bp = (char *) malloc(len + 1)) == NULL) {
      printf("Fehler: Kein Speicherplatz!\n");
      exit(1);
    }
    /* String von Puffer in Heap kopieren und in Vektor eintragen */
    str[nstr] = strcpy(bp, buf);
    ++nstr;
  }

  /* Stringvektor mit Zeilennummer ausgeben */
  for (n = 0; n < nstr; n++)
    printf("%3d: %s\n", n + 1, str[n]);

  exit(0);

} /* main() */
